HDU 2955 Robberies (0-1 backpack problem)

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

Write picture description here

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output
2
4
6

Note: where n is said to be less than 100, but I opened it all wrong into 1000 1e5 + 10 on the A
in the unusual idea of probability here will be calculated as the total value of the backpack, but because the probability of a float and therefore can not be used directly knapsack need each take 10 ^ n to convert a floating point number, the more trouble
so I chose to use the bank as a backpack gross amount of money, as the probability value, seek the maximum capacity of the backpack is not caught caught probability p Then the probability of not being caught is 1-p

So get the state transition equation: dp[j]=maxx(dp[j],dp[jm[i]]*(1-p[i]))

Code:

//0-1背包问题

//一个强盗想去b个银行进行偷到,已知每个银行最多可以被偷的钱数和被抓的概率,还知道他所能忍受的最大被抓概率
//问在可容忍的概率下最多可以偷多少钱
//在这里因为概率是浮点数 所以不好操作 故把钱数做背包容量,概率做价值求不被抓时最大的背包容量
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <cmath>

using namespace std;
const int N=1e5+10;
double p[N],dp[N];
int m[N];

double maxx(double aa,double bb)
{
    if(aa>bb) return aa;
    else return bb;
}

int main()
{
    ios::sync_with_stdio(false);
    int T;
    cin>>T;
    while(T--)
    {
        double a;
        int b;
        cin>>a>>b;
        memset(dp,0,sizeof(dp));
        int sum=0;
        for(int i=0; i<b; i++)
            cin>>m[i]>>p[i],sum+=m[i];
        dp[0]=1;
        for(int i=0; i<b; i++)
        {
            for(int j=sum; j>=m[i]; j--)
                dp[j]=maxx(dp[j],dp[j-m[i]]*(1-p[i]));
        }
        for(int i=sum; i>=0; i--)
        {
            if(dp[i]>(1-a))
            {
                cout<<i<<endl;
                break;
            }
        }
    }
    return 0;
}

Guess you like

Origin blog.csdn.net/Puppet__/article/details/79339793